#include "walk.hh"

namespace ell
{
	
	WalkCollector* walk
		(State* s, NeighborGenerator* ng, StateAcceptor* sa, 
		WalkAbortionCriterion* wac, WalkCollector* wc)
	{
		s = s->clone();
		wc->setAccepted(*s);
		while (!wac->abort(wc)) 
		{
			State::NeighborListPtr neighbors = ng->getNeighborList(s);
			State::NeighborList::Iterator it = neighbors->begin();
			
			bool go = false;
			// find new neighbor
			while (neighbors->end() != it && !go) 
			{				
				if (sa->accept(wc, *it)) 
				{
					delete s;
					s = (*it).clone();
					wc->setAccepted(*it);
					go = true;
				}
				else 
				{
					wc->setChecked(*it);
				}
				++it;
			}
			
			if (!go) {
				// didn't find new neighbor
				delete s;
				break;
			}
		}
		
		return wc;
	}
	
} //namespace ell
