#ifndef WALK_HH_
#define WALK_HH_


#include "State.hh"
#include "NeighborGenerator.hh"
#include "StateAcceptor.hh"
#include "WalkAbortionCriterion.hh"
#include "WalkCollector.hh"

namespace ell {
	/*!
	 * This function implements a generic walk starting from State s.
	 * The properties of this search are defined by the 
	 * implementations of NeighborhoodGenerator, StateAcceptor
	 * WalkAbortionCriterion and WalkCollector.
	 *  
	 * @author Daniel Maticzka
	 */
	WalkCollector* walk(
		State* s, NeighborGenerator* ng, 
		StateAcceptor* sa, WalkAbortionCriterion* wac, WalkCollector* wc);
} // end namespace ell

#endif /*WALK_HH_*/
