
#include "walkMC.hh"
#include "walk.hh"
#include "NeighborGenerator.hh"
#include "StateAcceptor.hh"
#include "WalkAbortionCriterion.hh"

namespace ell {

WalkCollector* 
walkMC(State* s, WalkCollector* wc, double beta) 
{
	NeighborGenerator* ng = new NG_Random();

	// Successor State is admitted using Metropolis criterion
	StateAcceptor* sa = new SA_Metropolis(beta);

	// No preset length of walk
	WalkAbortionCriterion* wac = new WAC_OpenEnd();

	wc = walk(s, ng, sa, wac, wc);

	delete ng;
	delete sa;
	delete wac;

	return wc;
}

} // end namespace ell
