#include "walkRandom.hh"
#include "walk.hh"
#include "NeighborGenerator.hh"
#include "StateAcceptor.hh"
#include "WalkAbortionCriterion.hh"

namespace ell {
	
	WalkCollector* walkRandom(
			State* s, 
			WalkCollector* wc,
			unsigned int length)
	{
		NeighborGenerator* ng = new NG_Random();
		
		// Succesor State mus have lesser energy
		StateAcceptor* sa = new SA_E_Le();
		
		// Finish random walk after computation of "length" successor states
		WalkAbortionCriterion* wac = new WAC_MaxLength(length);
		
		wc = walk(s, ng, sa, wac, wc);
		
		delete ng;
		delete sa;
		delete wac;
		
		return wc;
	}
	
} // end namespace ell
